'From Jasmine-rc1 of 7 October 2004 [latest update: #220] on 12 April 2005 at 8:18:47 pm'!
"Change Set:		VRMLCroquetImporter
Date:			12 April 2005
Author:			Dave Faught

This is a somewhat functional version of a VRML importer for Croquet.  It was largely copied directly from the VRMLWonderlandBuilder.  Along the way, some methods that didnt seem to be needed were dropped, and anything referring to an actor was renamed to a frame.  It still relies heavily on the B3D classes.  The VRMLCroquetBuilder>>doConvert: method was copied from a posting by Andreas Raab to convert from B3DIndexedMesh to TMesh.  There are many things in VRML that this probably will not handle, such as animation and prototypes.  A few other bugs still remain."!

TeapotMorph subclass: #TeaTestVRML
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-Import-VRML'!
VRMLEnumerator subclass: #VRMLCroquetBuilder
	instanceVariableNames: 'myTSpace scene attributes baseFrame currentFrame progress defaultCamera defaultMaterial '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-Import-VRML'!
Object subclass: #VRMLCroquetDistro
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Import-VRML'!

!TeaTestVRML methodsFor: 'initialization' stamp: 'daf 12/7/2004 19:41'!
initializeDefaultSpace
	| space |

	space _ TSpace new.
	space url: 'http://www.reed.com/TeaLand/spaces/intro.tea'.

	"Add a light to the world "
	self makeLight: space.

	" Add a few fun objects. "
	self makeFloor: space fileName:'stone.BMP'.

	self makePopUp: space.

	"self makeFrame: space fromVRML: 'c:\download\blender\STAGE.wrl'."
	"self makeFrame: space fromVRML: 'c:\download\blender\chevy.wrl'."
	"self makeFrame: space fromVRML: 'c:\download\vrml-tests\step-17.wrl'."
	"self makeFrame: space fromVRML: 'c:\download\blender\table.wrl'."
	"self makeFrame: space fromVRML: 'c:\download\blender\emeraldcity.wrl'."
	space addChild: (TDragger new contents:
		(self makeFrameFromVRML: 'STAGE.wrl') ).
	"space addChild: (TDragger new contents:
		(self makeFrameFromVRML: 'c:\download\blender\moebius.wrl') )."
	"space addChild: (TDragger new contents:
		(self makeFrameFromVRML: 'c:\download\blender\mh200Alpha02.wrl') )."

	^space! !

!TeaTestVRML methodsFor: 'converting' stamp: 'daf 12/2/2004 19:00'!
makeBaseFrameFrom: filename
	| baseFrame name |
	"Base frame creation"
	baseFrame _ TGroup new.
	name _ FileDirectory localNameFor: filename.
	(name findString: FileDirectory dot) = 0 ifFalse:[
		name _ name copyFrom: 1 to: (name findString: FileDirectory dot)-1].
	baseFrame objectName: name.

	^baseFrame! !

!TeaTestVRML methodsFor: 'converting' stamp: 'daf 12/3/2004 18:52'!
makeFrame: space fromVRML: filename
	"Creates a new frame using the specification from the given file"
	space addChild: (self makeFrameFromVRML: filename).
! !

!TeaTestVRML methodsFor: 'converting' stamp: 'daf 12/4/2004 09:59'!
makeFrameFromVRML: filename
	"Creates a new frame using the specification from the given file"
	| baseFrame parserClass builderClass scene |

	parserClass _ Smalltalk at: #VRMLNodeParser ifAbsent:[
		self reportErrorToUser:'No VRML parser found'.
		^self].
	builderClass _ Smalltalk at: #VRMLCroquetBuilder ifAbsent:[
		self reportErrorToUser:'No VRML to Croquet converter found'.
		^self].

	Cursor read showWhile:[
		baseFrame _ self makeBaseFrameFrom: filename.
		parserClass == nil
			ifFalse:[scene _ parserClass parseFileNamed: filename]. ].

"scene inspect."

	Cursor wait showWhile:[
		(builderClass == nil or:[scene == nil])
			ifFalse:[(builderClass on: scene) 
						baseFrame: baseFrame;
						buildFramesStart]. ].
	scene _ nil.

"baseFrame inspect."

	^ baseFrame.
! !


!TeaTestVRML class methodsFor: 'as yet unclassified' stamp: 'daf 11/27/2004 10:26'!
descriptionForPartsBin
	^ self partName:	(self name)
		categories:		#('Croquet')
		documentation:	'Croquet Browser'
		sampleImageForm: TForm defaultForm.
! !

!TeaTestVRML class methodsFor: 'as yet unclassified' stamp: 'daf 11/27/2004 10:26'!
includeInNewMorphMenu

	^true! !


!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:05'!
baseFrame
	^baseFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:06'!
baseFrame: aTFrame
	baseFrame _ aTFrame.
	self currentFrame: baseFrame.! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 12/3/2004 21:04'!
buildFrames
	"Using the given VRML scene build a set of frames for TSpace"
	attributes _ Dictionary new.

"	Utilities informUserDuring:[:bar| 
		progress _ bar."
		scene doWith: self "]" .! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 12/3/2004 21:07'!
buildFramesStart
	"Using the given VRML scene build a set of frames"
	defaultMaterial _ TMaterial new.
	self buildFrames.! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:12'!
createFrameFor: aMesh
	^self createFrameFor: aMesh suffix:''! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:15'!
createFrameFor: aMesh defaultName: aString
	^self createFrameFor: aMesh
			name: (attributes at: #currentName ifAbsent:[aString])
			suffix: ''! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 12/1/2004 19:20'!
createFrameFor: aMesh name: aString suffix: suffix
	| frame |
	frame _ self createSimpleFrame: aMesh 
					named: aString, suffix
					parent: currentFrame.
	"frame material: (attributes at: #currentMaterial ifAbsent:[nil])."
	aMesh ifNotNil:[attributes at: #currentShape put: frame].
	^frame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:21'!
createFrameFor: aMesh suffix: aString
	^self createFrameFor: aMesh
			name: (attributes at: #currentName ifAbsent:['unnamed'])
			suffix: aString! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 12/1/2004 20:39'!
createSimpleFrame: aMesh named: aString parent: parentFrame
	| aTMesh |
	aMesh ifNotNil:[
		aTMesh _ (self doConvert: aMesh).
		aTMesh objectName: aString].
	parentFrame ifNotNil:[
		aTMesh parent: parentFrame.
		parentFrame addChild: aTMesh].
	^aTMesh! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:11'!
currentFrame
	^currentFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:11'!
currentFrame: aTFrame
	currentFrame _ aTFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 12/4/2004 09:53'!
doConvert: myMesh
	"convert from B3DIndexedMesh to TMesh"
	| mesh tmpMesh material transform |
	tmpMesh _ myMesh.
	material _ (attributes at: #currentMaterial).
	material ifNil:[material _ defaultMaterial].
	transform _ (attributes at: #transform ifAbsent:[nil]).
	transform ifNotNil:[tmpMesh _ tmpMesh transformBy: transform].
	mesh := TMesh new
        initializeWithVertices: tmpMesh vertices
        alias: nil
        norms: tmpMesh vertexNormals
        textureUV: tmpMesh texCoords
        faceGroups: {1. tmpMesh zeroBasedFaceGroup}
        material: material.
	mesh initBounds.
	^ mesh
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:27'!
assignIndexedColors: node in: mesh
	| attr colors colorIndex faces vertices |
	attributes at: #currentColors put: nil.
	(attr _ node attributeValueNamed: 'color') notNil
		ifTrue:[attr doWith: self].
	colors _ attributes at: #currentColors.
	(colors == nil or:[colors size = 0]) ifTrue:[^self].
	attr _ (node attributeValueNamed: 'colorIndex').
	attr size = 0 ifTrue:[attr _ (node attributeValueNamed:'coordIndex')].
	colorIndex _ ReadStream on: attr.
	faces _ mesh faces.
	1 to: faces size do:[:i|
		vertices _ (faces at: i) vertices.
		[colorIndex next = -1] whileTrue.
		colorIndex skip: -1.
		1 to: vertices size do:[:index|
			(vertices at: index) color: (colors at: colorIndex next + 1).
		].
	].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:27'!
assignIndexedNormals: node in: mesh
	| attr normals nrmlIndex faces vertices |
	attributes at: #currentNormals put: nil.
	(attr _ node attributeValueNamed: 'normal') notNil
		ifTrue:[attr doWith: self].
	normals _ attributes at: #currentNormals.
	normals == nil ifTrue:[^self].
	attr _ (node attributeValueNamed: 'normalIndex').
	attr size = 0 ifTrue:[attr _ (node attributeValueNamed: 'coordIndex')].
	nrmlIndex _ ReadStream on: attr.
	faces _ mesh faces.
	1 to: faces size do:[:i|
		vertices _ (faces at: i) vertices.
		[nrmlIndex next = -1] whileTrue.
		nrmlIndex skip: -1.
		1 to: vertices size do:[:index|
			(vertices at: index) normal: (normals at: nrmlIndex next + 1).
		].
	].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:28'!
assignIndexedTexCoords: node in: mesh
	| attr faces vertices texCoords texIndex |
	attributes at: #currentTexCoords put: nil.
	(attr _ node attributeValueNamed: 'texCoord') notNil
		ifTrue:[attr doWith: self].
	texCoords _ attributes at: #currentTexCoords.
	texCoords == nil ifTrue:[^self].
	attr _ (node attributeValueNamed: 'texCoordIndex').
	attr size = 0 ifTrue:[attr _ (node attributeValueNamed:'coordIndex')].
	texIndex _ ReadStream on: attr.
	faces _ mesh faces.
	1 to: faces size do:[:i|
		vertices _ (faces at: i) vertices.
		[texIndex next = -1] whileTrue.
		texIndex skip: -1.
		1 to: vertices size do:[:index|
			(vertices at: index) texCoord: (texCoords at: texIndex next + 1).
		].
	].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:22'!
doAppearance: node
	| attr |
	(attr _ node attributeValueNamed: 'material') notNil
		ifTrue:[attr doWith: self].
	(attr _ node attributeValueNamed: 'texture') notNil
		ifTrue:[attr doWith: self].
	(attr _ node attributeValueNamed: 'textureTransform') notNil
		ifTrue:[attr doWith: self].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 21:12'!
doBox: node
	| size box |
	size _ (node attributeValueNamed:'size').
	box _ B3DIndexedMesh vrml97Box.
	self createFrameFor: box defaultName:'box'.
"
	currentFrame resizeRightNow: size first @ size second @ size third undoable: false."
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:23'!
doColor: node
	| colors |
	colors _ (node attributeValueNamed: 'color').
	attributes at: #currentColors put: (colors collect:[:c| c asB3DColor])! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 21:12'!
doCone: node
	| radius height doSide doBottom cone |
	radius _ (node attributeValueNamed:'bottomRadius').
	height _ (node attributeValueNamed:'height').
	doSide _ (node attributeValueNamed:'side').
	doBottom _ (node attributeValueNamed:'bottom').
	cone _ B3DIndexedMesh vrml97Cone: doSide bottom: doBottom.
	self createFrameFor: cone defaultName:'cone'.
"
	currentFrame resizeRightNow: radius @ height @ radius undoable: false."
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:23'!
doCoordinate: node
	| attr points interpolator |
	(attr _ node attributeValueNamed: 'point') notNil ifTrue:[
		points _ self mfVec3fFrom: attr.
		(scene targetNodes includes: node) ifTrue:[
			interpolator _ nil.
			scene sourceNodes do:[:n|
				n actionsDo:[:set|
					set do:[:msg| msg receiver == node ifTrue:[interpolator _ n]]]].
			interpolator _ self mfVec3fFromInterpolator: interpolator.
		].
	].
	points == nil
		ifTrue:[attributes removeKey: #currentPoints]
		ifFalse:[attributes at: #currentPoints put: points].
	interpolator == nil
		ifTrue:[attributes removeKey: #interpolatorPoints ifAbsent:[]]
		ifFalse:[attributes at: #interpolatorPoints put: interpolator].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 21:12'!
doCylinder: node
	| radius height doSide doBottom doTop cylinder |
	radius _ (node attributeValueNamed:'radius').
	height _ (node attributeValueNamed:'height').
	doSide _ (node attributeValueNamed:'side').
	doBottom _ (node attributeValueNamed:'bottom').
	doTop _ (node attributeValueNamed:'top').
	cylinder _ B3DIndexedMesh vrml97Cylinder: doSide bottom: doBottom top: doTop.
	self createFrameFor: cylinder defaultName:'cylinder'.
"	currentFrame resizeRightNow: radius @ height @ radius undoable: false."
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 21:37'!
doDirectionalLight: node
	| ambientIntensity intensity color on light dir |
	ambientIntensity _ (node attributeValueNamed:'ambientIntensity').
	intensity _ (node attributeValueNamed: 'intensity').
	color _ (node attributeValueNamed: 'color').
	dir _ self positionFrom: (node attributeValueNamed:'direction').
	on _ (node attributeValueNamed:'on').
	light _ TLight new type: #directional.
	light ambientColor: (color * ambientIntensity).
	light diffuseColor: (color * intensity).
	light spotDirection: dir.
	currentFrame ifNotNil:[
		light parent: currentFrame.
		currentFrame addChild: light].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:24'!
doImageTexture: node
	| attr texFileName tex |
	"Create a new texture."
	(attr _ node attributeValueNamed: 'url') notNil
		ifTrue:[
			texFileName _ (FileDirectory on: (FileDirectory dirPathFor: scene fileURL)) fullNameFor: attr first.
			(FileDirectory default fileExists: texFileName)
				ifTrue:[tex _ TTexture new initializeWithFileName: texFileName].
			attributes at: #currentTexture put: tex].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:24'!
doIndexedFaceSet: node
	| attr faces points mesh ipPoints meshList map |
	attributes at: #currentPoints put: nil.
	(attr _ node attributeValueNamed: 'coord') notNil
		ifTrue:[attr doWith: self].
	points _ attributes at: #currentPoints.
	ipPoints _ attributes at: #interpolatorPoints ifAbsent:[nil].
	points ifNil:[^self].
	(attr _ node attributeValueNamed: 'coordIndex') notNil
		ifTrue:[faces _ self facesFrom: attr for: points].
	faces ifNil:[^self].
	mesh _ B3DSimpleMesh withAll: faces.
	self assignIndexedNormals: node in: mesh.
	self assignIndexedTexCoords: node in: mesh.
	self assignIndexedColors: node in: mesh.
	mesh _ mesh asIndexedTriangleMesh.
	ipPoints == nil ifFalse:[
		"Re-map points for interpolated meshes"
		map _ Dictionary new: points size * 2.
		points doWithIndex:[:pt :index| map at: pt put: index].
		meshList _ ipPoints collect:[:pts|
			mesh clone vertices: (mesh vertices collect:[:pt| pts at: (map at: pt)])].
		mesh _ B3DInterpolatedMesh new initialize meshes: meshList.
	].
	self createFrameFor: mesh.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:24'!
doLOD: node
	| levels |
	levels _ (node attributeValueNamed: 'level').
	levels size > 0 ifTrue:[
		levels last doWith: self.
	].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 20:57'!
doMaterial: node
	| ambientIntensity diffuseColor emissiveColor shininess specularColor material transparency |
	ambientIntensity _ (node attributeValueNamed: 'ambientIntensity').
	diffuseColor _ (node attributeValueNamed: 'diffuseColor').
	emissiveColor _ (node attributeValueNamed:'emissiveColor').
	shininess _ (node attributeValueNamed: 'shininess').
	specularColor _ (node attributeValueNamed: 'specularColor').
	transparency _ (node attributeValueNamed:'transparency').
	material _ TMaterial new.
	material ambientColor: ((diffuseColor * ambientIntensity) alpha: 1.0).
	material diffuseColor: diffuseColor.
	material specularColor: specularColor.
	material emissiveColor: emissiveColor.
	material shininess: shininess.
	material transparency: (1 - transparency).  "this is reversed?"
	attributes at: #currentMaterial put: material.! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/2/2004 19:16'!
doNamedNode: node
	| lastName |
"	progress value:'Creating ', node name,' ...'."
	lastName _ attributes at: #currentName ifAbsent:[nil].
	attributes at: #currentName put: node name.
	super doNamedNode: node.
	lastName
		ifNil:[attributes removeKey: #currentName]
		ifNotNil:[attributes at: #currentName put: lastName].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:25'!
doNormal: node
	| attr points |
	(attr _ node attributeValueNamed: 'vector') notNil
		ifTrue:[points _ self mfVec3fFrom: attr].
	points == nil
		ifTrue:[attributes removeKey: #currentNormals]
		ifFalse:[attributes at: #currentNormals put: points].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:25'!
doShape: node
	| attr |
	attributes at: #currentTexture put: nil.
	attributes at: #currentMaterial put: nil.
	attributes at: #currentShape put: nil.
	(attr _ node attributeValueNamed: 'appearance') notNil
		ifTrue:[attr doWith: self].
	(attr _ node attributeValueNamed: 'geometry') notNil
		ifTrue:[attr doWith: self].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 21:13'!
doSphere: node
	| radius sphere |
	radius _ (node attributeValueNamed:'radius').
	sphere _ B3DIndexedMesh vrml97Sphere.
	self createFrameFor: sphere defaultName:'sphere'.
"
	currentFrame resizeRightNow: radius @ radius @ radius undoable: false."
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:25'!
doSwitch: node
	| choices which |
	choices _ (node attributeValueNamed:'choices').
	which _ (node attributeValueNamed: 'whichChoice') + 1.
	(which > 0 and:[which <= choices size])
		ifTrue:[(choices at: which) doWith: self].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/1/2004 20:25'!
doTextureCoordinate: node
	| attr points |
	(attr _ node attributeValueNamed: 'point') notNil
		ifTrue:[points _ self mfVec2fFrom: attr].
	points == nil
		ifTrue:[attributes removeKey: #currentTexCoords]
		ifFalse:[attributes at: #currentTexCoords put: points].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/4/2004 09:19'!
doTransform: node
	| attr c r s sr t xform |
	attr _ node attributeValueNamed: 'center'.
	attr notNil ifTrue:[c _ self positionFrom: attr].
	attr _ node attributeValueNamed: 'rotation'.
	attr notNil ifTrue:[r _ self rotationFrom: attr].
	attr _ node attributeValueNamed: 'scale'.
	attr notNil ifTrue:[s _ self scaleFrom: attr].
	attr _ node attributeValueNamed: 'scaleOrientation'.
	attr notNil ifTrue:[sr _ self rotationFrom: attr].
	attr _ node attributeValueNamed: 'translation'.
	attr notNil ifTrue:[t _ self positionFrom: attr].
	xform _ B3DMatrix4x4 identity.
	xform translation: t+c.
	xform _ xform composedWithLocal: r asMatrix4x4.
	xform _ xform composedWithLocal: sr asMatrix4x4.
	xform _ xform composedWithLocal: (B3DMatrix4x4 identity scaling: s).
	xform _ xform composedWithLocal: sr negated asMatrix4x4.
	xform _ xform composedWithLocal: (B3DMatrix4x4 identity translation: c negated).
	attributes at: #transform put: xform.
	super doTransform: node.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 12/3/2004 21:18'!
doViewpoint: node
	| attr pos r fov name m camera |
	attr _ node attributeValueNamed: 'position'.
	attr notNil ifTrue:[pos _ self positionFrom: attr].
	attr _ node attributeValueNamed: 'orientation'.
	attr notNil ifTrue:[r _ self rotationFrom: attr].
	attr _ node attributeValueNamed: 'fieldOfView'.
	attr notNil ifTrue:[fov _ attr radiansToDegrees].
	attr _ node attributeValueNamed: 'description'.
	attr notNil ifTrue:[name _ attr].
	m _ B3DMatrix4x4 identity.
	m _ m composedWithGlobal: (r asMatrix4x4).
	m _ m composedWithGlobal: (B3DMatrix4x4 withOffset: pos).

"	camera _ TCamera new initializeWithViewPort: (TeapotMorph current).
	currentFrame addChild: camera.
	camera viewAngle: m.
	camera setFieldOfView: fov."
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 19:39'!
facesFrom: anArray for: vertices
	"Create and return a set of faces from the given index array"
	| faces vtx |
	vtx _ WriteStream on: (Array new: 4).
	faces _ WriteStream on: (Array new: anArray size // 4).
	anArray do:[:idx|
		idx = -1 ifTrue:[
			vtx position > 2 
				ifTrue:[faces nextPut: (B3DSimpleMeshFace withAll: vtx contents)].
			vtx reset.
		] ifFalse:[
			vtx nextPut: (B3DSimpleMeshVertex new position: (vertices at: idx+1)).
		].
	].
	^faces contents! !

!VRMLCroquetBuilder methodsFor: 'initialize' stamp: 'daf 11/27/2004 09:00'!
on: aVRMLScene
	scene _ aVRMLScene! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
mfVec2fFrom: anArray
	"Convert the given array into a B3DVector2Array"
	| pts |
	pts _ WriteStream on: (B3DTexture2Array new: anArray size).
	anArray do:[:spec|
		pts nextPut: (B3DVector2 u: (spec at: 1) v: (spec at: 2)).
	].
	^pts contents! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 12/2/2004 21:21'!
mfVec3fFrom: anArray
	"Convert the given array into a B3DVector3Array"
	| pts |
	pts _ WriteStream on: (B3DVector3Array new: anArray size).
	anArray do:[:spec|
		pts nextPut: (B3DVector3 x: (spec at: 1) y: (spec at: 2) z: (spec at: 3)).
	].
	^pts contents! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
mfVec3fFromInterpolator: node
	| key value len values vv keySize |
	key _ node attributeValueNamed: 'key'.
	value _ node attributeValueNamed: 'keyValue'.
	keySize _ key size.
	values _ Array new: keySize.
	len _ value size // keySize.
	1 to: values size do:[:i|
		vv _ B3DVector3Array new: len.
		vv replaceFrom: 1 to: len with: value startingAt: (i-1 * len)+1.
		values at: i put: (self mfVec3fFrom: vv).
	].
	^values! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 12/2/2004 21:20'!
positionFrom: attr
	"Fix up coord systems"
	^B3DVector3 x: (attr at: 1) y: (attr at: 2) z: (attr at: 3).
! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
rotationFrom: attr
	"Fix up coord systems.
	FIXME: attr should always be a B3DRotation but for now
	the defaults are arrays. How ugly..."
	attr class == Array
		ifTrue:[^B3DRotation radiansAngle: (attr at: 4) negated axis: 
			(B3DVector3 x: (attr at: 1) y: (attr at: 2) z: (attr at: 3))]
		ifFalse:[^attr negated]! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
scaleFrom: attr
	"Fix up coord systems"
	^B3DVector3 x: (attr at: 1) y: (attr at: 2) z: (attr at: 3).
! !


!VRMLCroquetBuilder class methodsFor: 'instance creation' stamp: 'daf 11/27/2004 09:00'!
on: aVRMLScene
	^self new on: aVRMLScene! !


!VRMLCroquetDistro methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:22'!
seeClassSide! !


!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:36'!
changeSetBaseFileNames
	"VRMLCroquetDistro changeSetBaseFileNames"
	^self changeSetFullFileNames collect: [ :ea | FileDirectory localNameFor: ea ]! !

!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:32'!
changeSetDirectory
	^FileDirectory default! !

!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:25'!
changeSetFullFileNames
	"VRMLCroquetDistro changeSetFullFileNames"
	| dir |
	dir _ self changeSetDirectory.
	^self changeSets collect: [ :s | 
		dir fullNameFor: (dir lastNameFor: s extension: 'cs') ]
! !

!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:28'!
changeSets
	^{
'VRMLCroquetImporter'.
}
! !

!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:40'!
makeSAR
	"
	VRMLCroquetDistro makeSAR
	"
	| sar result sarName |
	sar _ ZipArchive new.
	self changeSetFullFileNames do: [ :fileName | sar addFile: fileName as: (FileDirectory localNameFor: fileName) ].
	self otherFileNames do: [ :fileName | sar addFile: fileName as: fileName ].

	sar addString: self preambleText as: 'install/preamble'.
"	sar addString: self postscriptText as: 'install/postscript'."

	result _ StandardFileMenu newFile.
	result ifNil: [ ^nil ].
	sarName _ (result directory fullNameFor: result name).
	sar writeToFileNamed: sarName.
! !

!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:40'!
otherFileNames
	" VRMLCroquetDistro otherFileNames "
	^#('STAGE.wrl')

"	^#('STAGE.wrl' 'NCSketchMorph.st')"
! !

!VRMLCroquetDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/7/2004 19:38'!
preambleText
	"
	VRMLCroquetDistro preambleText
	"

	^String streamContents: [ :stream |
		self changeSetBaseFileNames do: [ :csName |
			stream nextPutAll: 'self fileInMemberNamed: ';
				print: csName; nextPut: $.; cr ].
		stream nextPutAll: 'self extractMember: ';
			print: 'STAGE.wrl'; nextPut: $.; cr.
	]
! !


!VRMLNodeParser class methodsFor: 'instance creation' stamp: 'oxe 2/25/2005 14:30'!
parseFileNamed: aString
	"VRMLNodeParser parseFileNamed:'C:\WDI-Website\Link 3D Models\08-17-99\vrml\test.wrl'"
	"MessageTally spyOn:[
		VRMLNodeParser 
			parseFileNamed:'C:\WDI-Website\Link 3D Models\08-17-99\vrml\linkvrml97.WRL']"
	| stream result |
	stream := FileStream readOnlyFileNamed: aString.
	stream size < 500000 "cache in memory"
		ifTrue:[result _ self parse: (ReadStream on: stream contentsOfEntireFile) url: stream name]
		ifFalse:[result := self parse: stream url: stream name].
	stream close.
	^result! !

VRMLCroquetBuilder removeSelector: #initializeFor:!

!VRMLCroquetBuilder reorganize!
('building frames' baseFrame baseFrame: buildFrames buildFramesStart createFrameFor: createFrameFor:defaultName: createFrameFor:name:suffix: createFrameFor:suffix: createSimpleFrame:named:parent: currentFrame currentFrame: doConvert:)
('enumerating nodes' assignIndexedColors:in: assignIndexedNormals:in: assignIndexedTexCoords:in: doAppearance: doBox: doColor: doCone: doCoordinate: doCylinder: doDirectionalLight: doImageTexture: doIndexedFaceSet: doLOD: doMaterial: doNamedNode: doNormal: doShape: doSphere: doSwitch: doTextureCoordinate: doTransform: doViewpoint: facesFrom:for:)
('enumerating')
('initialize' on:)
('converting' mfVec2fFrom: mfVec3fFrom: mfVec3fFromInterpolator: positionFrom: rotationFrom: scaleFrom:)
!

